<?php

/**
 * @file
 *
 * Utility file for Spectra Connect API operations
 */

namespace Drupal\spectra_connect;

use Drupal\spectra_connect\Entity\SpectraConnect;

/**
 * Class SpectraConnectUtilities
 * @package Drupal\spectra_connect
 *
 * Utility class
 * TODO: add queueing and failure handling
 * TODO: add backtraces from /web/core/includes/errors.inc
 */
class SpectraConnectUtilities {
  
  public static function spectra_post($connector, $data) {
    $conn = SpectraConnect::load($connector);
    if ($conn) {
      $plugin = $conn->plugin;
      if ($plugin) {
        $data['plugin'] = $plugin;
      }
      $endpoint = $conn->post_endpoint;
      $api_key = $conn->api_key;
      $headers = [];
      $headers['api-key'] = $api_key;
      $headers['Accept'] = 'application/json';
      $headers['Content-type'] = 'application/json';
      $options = ['headers' => $headers, 'body' => json_encode($data)];
      $response = \Drupal::httpClient()->request('POST', $endpoint, $options);
      return $response;
    }
    else {
      return FALSE;
    }
  }

  public static function spectra_get($connector, $data) {
    $conn = SpectraConnect::load($connector);
    if ($conn) {
      $plugin = $conn->plugin;
      if ($plugin) {
        $data['plugin'] = $plugin;
      }
      $endpoint = $conn->get_endpoint;
      $api_key = $conn->api_key;
      $headers = [];
      $headers['api-key'] = $api_key;
      $headers['Accept'] = 'application/json';
      $headers['Content-type'] = 'application/json';

      // Build query string
      // TODO add the Url class, and build the URL the right way
      $query_string = http_build_query($data);
      $query_append = strpos($endpoint, '?') !== FALSE ? '&' : '?';
      $url = $endpoint . $query_append . $query_string;
      $options = ['headers' => $headers];
      $response = \Drupal::httpClient()->request('GET', $url, $options);
      return $response;
    }
    else {
      return FALSE;
    }
  }
}